
laggedVar <- function (d, sData, lVar = NULL, lagBy = 1, tID = "year", gID = "GWNo") {
  if(is.null(lVar)) {
    stop("Name of variable required")
  }
  
  getData <- function(data = d, sourceData = sData, lagVar = lVar, lg = lagBy, timeID = tID, groupID = gID) {
    
    for(y in data[ , timeID]) {
      
      lag_tx <- subset(sourceData, get(timeID) == (y - lg) & get(groupID) == data[1, groupID], select = lagVar)
      # diagnostic / debug print commands
      # print(paste("Found", lag_tx, "in year:", y, "for country:", as.character(subset(data, year == y, select = location))))
      # print(length(lag_tx))
      if(!is.null(lag_tx) & !(nrow(lag_tx) == 0) ) {
        data[data[timeID] == y, paste0(lagVar, "_t", abs(lg))] <- lag_tx
      }
      else {
        data[data[timeID] == y, paste0(lagVar, "_t", abs(lg))] <- NA
      }
    }
    
    return(data)
  }
  
#  require(plyr)
  
  df <- plyr::ddply(.data = d, .variables = gID, .fun = getData)
  return(df)
}